#include<bits/stdc++.h>
using namespace std;
int main()
{
    ifstream f1("sortMT.inp");
    ofstream f2("sortMT.out");
    int n,m;
    f1>>m>>n;
    int a[m][n];
    int mx=0;
    for(int i=0;i<m;i++)
    {
        for (int j=0;j<n;j++)
        {
            f1>>a[i][j];
            if (mx<a[i][j])
            {
                mx=a[i][j];
            }
        }
    }
    int mn=a[0][0];
    for(int i=0;i<m;i++)
    {
        for (int j=0;j<n;j++)
        {
            if(mn>a[i][j])
            {
                mn=a[i][j];
            }
        }
    }
    f2<<mx<<" "<<mn;
    for(int k = 0; k<m ; k++)
        {
            for(int i = 0; i<n-1 ; i++)
            {
                for(int j = n-1; j>i ; j--)
                {
                    if(a[k][j]<a[k][j-1])
                    {
                        int temp = a[k][j];
                        a[k][j] = a[k][j-1];
                        a[k][j-1] = temp;
                    }
                }
            }
        }

    for(int i = 0; i<m ; i++)
        {
            f2<<endl;
            for(int j = 0; j<n ; j++)
                {
                    f2<<a[i][j]<<" ";
                }
        }
}
